<%
	'************************************************************************************
	'*																					*
	'*	Checks to see if the user passed in is the owner of the gallery passed in.		*
	'*																					*
	'************************************************************************************
	Function G_ADMINISTRATION_IsGalleryOwner(iAccountUnq, iGalleryUnq, iImageUnq)
		Dim rsImageGallery, sSQLText
		G_ADMINISTRATION_IsGalleryOwner = FALSE
		
		If ( iGalleryUnq <> "" ) And ( iAccountUnq <> "" ) Then
			Set rsImageGallery = CreateObject("ADODB.Recordset")
			sSQLText = "SELECT GalleryUnq FROM Galleries (NOLOCK) WHERE AccountUnq = " & iAccountUnq & " AND GalleryUnq = " & iGalleryUnq
			rsImageGallery.Open sSQLText, ImageGalleryConnection, adOpenKeyset, adLockReadOnly, adCmdText
			If ( NOT rsImageGallery.EOF ) Then
				G_ADMINISTRATION_IsGalleryOwner = TRUE
			End If
			rsImageGallery.Close
			
			If ( iImageUnq <> "" ) Then
				' check to make sure that this imageunq is actually in this gallery
				'	( DO NOT check for Accountunq because an admin can upload to galleries 
				'	they don't own, but the gallery owner should still be able to admin those 
				'	images because they are in their gallery -- even though another person uploaded them)
				If ( G_ADMINISTRATION_IsGalleryOwner ) Then
					' they have to be the gallery owner even before bothering to check if the image is in that gallery
					sSQLText = "SELECT GalleryUnq FROM ImagesInGallery (NOLOCK) WHERE GalleryUnq = " & iGalleryUnq & " AND ImageUnq = " & iImageUnq
					rsImageGallery.Open sSQLText, ImageGalleryConnection, adOpenKeyset, adLockReadOnly, adCmdText
					If ( NOT rsImageGallery.EOF ) Then
						G_ADMINISTRATION_IsGalleryOwner = TRUE
					Else
						' since the image isn't in the gallery that they own, return false -- the user might be trying to spoof by saying they are editing a gallery they own, but an image they don't own
						G_ADMINISTRATION_IsGalleryOwner = FALSE
					End If
					rsImageGallery.Close
				End If
			End If
			
			Set rsImageGallery = Nothing
		End If
		
	End Function
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*	Returns the AccountUnq of the gallery - used to know where to save files, etc..	*
	'*																					*
	'************************************************************************************
	Function G_ADMINISTRATION_GetGalleryOwner(iGalleryUnq)
		Dim rsImageGallery, sSQLText
		
		If ( iGalleryUnq <> "" ) Then
			Set rsImageGallery = CreateObject("ADODB.Recordset")
			sSQLText = "SELECT AccountUnq FROM Galleries (NOLOCK) WHERE GalleryUnq = " & iGalleryUnq
			rsImageGallery.Open sSQLText, ImageGalleryConnection, adOpenKeyset, adLockReadOnly, adCmdText
			If ( NOT rsImageGallery.EOF ) Then
				G_ADMINISTRATION_GetGalleryOwner = rsImageGallery("AccountUnq")
			End If
			rsImageGallery.Close
			Set rsImageGallery = Nothing
		End If
	End Function
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*	Returns TRUE if the current user has access to the images in the gallery.		*
	'*		Also returns TRUE if the user owns the gallery or has SB_IG_ADMIN_ALL 		*
	'*		rights.																		*
	'*																					*
	'************************************************************************************
	Function G_ADMINISTRATION_AccessLocked(sGalleryUnq, sGalleryOwner)
		Dim rsGallery, rsGallery2, sSQLText
		
		G_ADMINISTRATION_AccessLocked = FALSE
	
		If ( ( ACCNT_SpecificDomain("SB_IG_ADMIN_ALL", iDomainName) ) Or ( CDbl(sGalleryOwner) = CDbl(iLoginAccountUnq) ) ) Then
			G_ADMINISTRATION_AccessLocked = TRUE
		Else
			Set rsGallery = CreateObject("ADODB.Recordset")
			' check to see if the current user is in the list of accounts
			If ( NOT IsNumeric(sGalleryUnq) ) Then	' some wankers were changing the querystring to put 8_8 as the galleryunq...why??
				sGalleryUnq = "-1"
			End If
			sSQLText = "SELECT * FROM PrivateAccounts (NOLOCK) WHERE GalleryUnq = " & sGalleryUnq & " AND AccountUnq = " & iLoginAccountUnq
			rsGallery.Open sSQLText, ImageGalleryConnection, adOpenKeyset, adLockReadOnly, adCmdText
			If ( NOT rsGallery.EOF ) Then
				rsGallery.Close
				G_ADMINISTRATION_AccessLocked = TRUE	' yes they can access this locked gallery because the current users accountunq is in the list for this gallery
			Else
				' now we must check to see if the user is in any Groups - if so, we have to check if any of those Groups are allowed in this gallery
				rsGallery.Close
				Set rsGallery2 = CreateObject("ADODB.Recordset")
				sSQLText = "SELECT G.GroupUnq FROM GroupMap M (NOLOCK), Groups G (NOLOCK) WHERE M.AccountUnq = " & iLoginAccountUnq & " AND M.GroupUnq = G.GroupUnq AND G.DomainUnq = " & iDomainName & " AND G.DomainUnq = M.DomainUnq"
				rsGallery.Open sSQLText, AccountsConnection, adOpenKeyset, adLockReadOnly, adCmdText
				If ( NOT rsGallery.EOF ) Then
					Do While ( NOT rsGallery.EOF )
						' loop through all the Groups the user is in, checking if the Group is in the list of Groups that can access this gallery
						sSQLText = "SELECT GalleryUnq FROM PrivateGroups (NOLOCK) WHERE GalleryUnq = " & sGalleryUnq & " AND GroupUnq = " & rsGallery("GroupUnq")
						rsGallery2.Open sSQLText, ImageGalleryConnection, adOpenKeyset, adLockReadOnly, adCmdText
						If ( NOT rsGallery2.EOF ) Then
							G_ADMINISTRATION_AccessLocked = TRUE
							Exit Do
						End If
						rsGallery2.Close
						rsGallery.MoveNext
					Loop
				End If
				rsGallery.Close

				' not found anywhere for the individual so fall back on the global setting - do it this way because
				'	if we choose the global setting first, we might miss the fact that the individual may have more
				'	access than the global access!
				If ( G_ADMINISTRATION_AccessLocked = FALSE ) Then
					sSQLText = "SELECT * FROM PrivateAccounts (NOLOCK) WHERE GalleryUnq = " & sGalleryUnq & " AND AccountUnq = -1"
					rsGallery2.Open sSQLText, ImageGalleryConnection, adOpenKeyset, adLockReadOnly, adCmdText
					If ( NOT rsGallery2.EOF ) Then
						G_ADMINISTRATION_AccessLocked = TRUE	' yes they can access this locked gallery because it's AccountUnq is = -1
					End If
					rsGallery2.Close
				End If
				Set rsGallery2 = Nothing
			End If
			Set rsGallery = Nothing
		End If

	End Function
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*	Returns the number of images that the user can still download for today, or		*
	'*		-1 if they can download an unlimited number.								*
	'*																					*
	'************************************************************************************
	Function G_ADMINISTRATION_DailyDLLeft(iAccountUnq, iDomainUnq)
		Dim iCookieValue, iNonMmbrNumDl
		Dim iNumDlDay, iNumDlToday, dLastDlDate
		
		If ( bHasAccount ) Then
			' the user is a member, check the SB_IG_NUM_DL_DAY and SB_IG_NUM_HAS_DL
			'	--num downloads per day
			'		--SB_IG_NUM_DL_DAY
			'	--num files user has downloaded today
			'		--SB_IG_NUM_HAS_DL
			'	--last date/time user downloaded a file
			'		--SB_IG_DL_LASTDATE
			iNumDlDay = Trim(ACCNT_ReturnADV_W_DomainUnq("SB_IG_NUM_DL_DAY", "V", iAccountUnq, 7, "PRIVATE", iDomainUnq))
			If ( iNumDlDay = "" ) Then
				iNumDlDay = Trim(DOMAIN_Conf("IMAGEGALLERY_INITIAL_NUMDOWNLOADS"))
				Call ACCNT_WriteADV("SB_IG_NUM_DL_DAY", iNumDlDay, "V", iAccountUnq, iDomainName, "PRIVATE")
			End If
			
			iNumDlDay = CDbl(iNumDlDay)
			If ( iNumDlDay = -1 ) then
				G_ADMINISTRATION_DailyDLLeft = -1
			Else
				iNumDlToday = Trim(ACCNT_ReturnADV_W_DomainUnq("SB_IG_NUM_HAS_DL", "V", iAccountUnq, 7, "PRIVATE", iDomainUnq))
				dLastDlDate = Trim(ACCNT_ReturnADV_W_DomainUnq("SB_IG_DL_LASTDATE", "V", iAccountUnq, 7, "PRIVATE", iDomainUnq))
				If ( iNumDlToday = "" ) Then
					iNumDlToday = 0
				End If
				If ( dLastDlDate = "" ) Then
					dLastDlDate = now 'CDate("1/1/80")
				End If
				If ( DateDiff("d", dLastDlDate, NOW) >= 1 ) Then
					' they have not downloaded a file within a day
					G_ADMINISTRATION_DailyDLLeft = iNumDlDay
				Else
					G_ADMINISTRATION_DailyDLLeft = iNumDlDay - iNumDlToday
					If ( G_ADMINISTRATION_DailyDLLeft = -1 ) Then
						' this is because we've already checked to see if nonmmbrs can dl unlimited - they cannot, so the difference of the ttl downloadable
						'	and the num they have downloaded today just happened to be -1
						G_ADMINISTRATION_DailyDLLeft = 0
					End If
				End If
			End If
		Else
			' the user is not a member, check the IMAGEGALLERY_NONMMBR_NUMDOWNLOADS conf
			'	variable compared to their cookie
			
			' first check to see if the user_agent is a robot. if so, let them dl any number -- don't track it
			sTemp = Trim(UCase(DOMAIN_Text("ROBOT_LIST")))
			If ( ( InStr(sTemp, UCase(Request.ServerVariables("HTTP_USER_AGENT"))) > 0 ) And ( sTemp <> "" ) ) Then
				G_ADMINISTRATION_DailyDLLeft = -1
			Else
				iNonMmbrNumDl = CDbl(Trim(DOMAIN_Conf("IMAGEGALLERY_NONMMBR_NUMDOWNLOADS")))
				If ( iNonMmbrNumDl = -1 ) Then
					G_ADMINISTRATION_DailyDLLeft = -1
				Else
					iCookieValue = Trim(Request.Cookies("SB_IG_NUM_HAS_DL" & iDomainName))
					If ( iCookieValue = "" ) Then
						' their cookie is blank so they have not downloaded any images yet
						G_ADMINISTRATION_DailyDLLeft = iNonMmbrNumDl
					Else
						iCookieValue = CDbl(iCookieValue)
						G_ADMINISTRATION_DailyDLLeft = iNonMmbrNumDl - iCookieValue
						If ( G_ADMINISTRATION_DailyDLLeft = -1 ) Then
							' this is because we've already checked to see if nonmmbrs can dl unlimited - they cannot, so the difference of the cookie and
							'	conf var just happened to be -1
							G_ADMINISTRATION_DailyDLLeft = 0
						End If
					End If
				End If
			End If
		End If
		
	End Function
	'************************************************************************************
	
	
	
	'************************************************************************************
	'*																					*
	'*	Increments the number of images the user has downloaded for today.				*
	'*	If the user is not a member, sets and increments the cookie.					*
	'*																					*
	'************************************************************************************
	Sub G_ADMINISTRATION_IncrementDailyDL(iAccountUnq)
		Dim iNumDL, dLastDL, sTemp
	
		If ( bHasAccount ) Then
			' they are a member, increment SB_IG_NUM_HAS_DL ADV and set the SB_IG_DL_LASTDATE to now
			dLastDL = Trim(ACCNT_ReturnADV("SB_IG_DL_LASTDATE", "V", iAccountUnq, 7, "PRIVATE"))
			
			If ( dLastDL = "" ) Then
				iNumDL = "1"
			Else
				If ( DateDiff("d", CDate(dLastDL), NOW) > 0 ) Then
					Call ACCNT_WriteADV("SB_IG_DL_LASTDATE", NOW, "V", iAccountUnq, iDomainName, "PRIVATE")
					iNumDL = "1"
				Else
					iNumDL = CDbl(Trim(ACCNT_ReturnADV("SB_IG_NUM_HAS_DL", "V", iAccountUnq, 7, "PRIVATE"))) + 1
				End If
			End If
			Call ACCNT_WriteADV("SB_IG_NUM_HAS_DL", iNumDL, "V", iAccountUnq, iDomainName, "PRIVATE")
			Call ACCNT_WriteADV("SB_IG_DL_LASTDATE", NOW, "V", iAccountUnq, iDomainName, "PRIVATE")
		Else
			' they are not a member so create (if not already there) a cookie and increment it by one
			sTemp = Trim(Request.Cookies("SB_IG_NUM_HAS_DL" & iDomainName))
			If ( sTemp = "" ) Then
				iNumDL = 1
			Else
				iNumDL = CDbl(sTemp) + 1
			End If
			Response.Cookies("SB_IG_NUM_HAS_DL" & iDomainName) = CStr(iNumDL)
			Response.Cookies("SB_IG_NUM_HAS_DL" & iDomainName).Path = "/"
			Response.Cookies("SB_IG_NUM_HAS_DL" & iDomainName).Expires = CDate(FormatDateTime(DateAdd("d", 1, NOW), 2))	' expire first thing tomorrow
			Response.Cookies("SB_IG_NUM_HAS_DL" & iDomainName).Domain = Request.ServerVariables("SERVER_NAME")
		End If

	End Sub
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*	Returns the valid file extensions for the accountunq passed in.					*
	'*																					*
	'************************************************************************************
	Function G_ADMINISTRATION_ValidFileExtensions(iAccountUnq, iDomainUnq)
		
		G_ADMINISTRATION_ValidFileExtensions = Trim(ACCNT_ReturnADV_W_DomainUnq("SB_IG_UPLOADTYPE", "V", iAccountUnq, 7, "OVERRIDE", iDomainUnq))
		If ( G_ADMINISTRATION_ValidFileExtensions = "" ) Then
			G_ADMINISTRATION_ValidFileExtensions = Trim(DOMAIN_Conf_W_DomainUnq("IMAGEGALLERY_INITIAL_UPLOADTYPE", iDomainUnq))
			Call ACCNT_WriteADV("SB_IG_UPLOADTYPE", G_ADMINISTRATION_ValidFileExtensions, "V", iAccountUnq, iDomainUnq, "PRIVATE")
		End If
		
	End Function
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*	Returns the max file size in bytes or -1 for unlimited for the accountunq 		*
	'*		passed in.																	*
	'*																					*
	'************************************************************************************
	Function G_ADMINISTRATION_MaxFileSize(iAccountUnq, iDomainUnq)
		
		G_ADMINISTRATION_MaxFileSize = Trim(ACCNT_ReturnADV_W_DomainUnq("SB_IG_UPLOADBYTES", "V", iAccountUnq, 7, "OVERRIDE", iDomainUnq))
		If ( G_ADMINISTRATION_MaxFileSize = "" ) Then
			G_ADMINISTRATION_MaxFileSize = Trim(DOMAIN_Conf_W_DomainUnq("IMAGEGALLERY_INITIAL_UPLOADBYTES", iDomainUnq))
			Call ACCNT_WriteADV("SB_IG_UPLOADBYTES", G_ADMINISTRATION_MaxFileSize, "V", iAccountUnq, iDomainUnq, "PRIVATE")
		End If
		
		If ( G_ADMINISTRATION_MaxFileSize = "" ) Then
			G_ADMINISTRATION_MaxFileSize = 0
		Else
			G_ADMINISTRATION_MaxFileSize = CDbl(G_ADMINISTRATION_MaxFileSize)
		End If
		
	End Function
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*	Returns the number of images that the user can still upload, or					*
	'*		-1 if they can upload an unlimited number.									*
	'*																					*
	'************************************************************************************
	Function G_ADMINISTRATION_ULLeft(iAccountUnq, iDomainUnq)
		Dim iULAllowed, iULAlready
	
		'--num files user can upload
		'	--SB_IG_NUMALLOWED
		'--num files user has uploaded
		'	--SB_IG_NUMUPLOADED
		iULAllowed = Trim(ACCNT_ReturnADV_W_DomainUnq("SB_IG_NUMALLOWED", "V", iAccountUnq, 7, "OVERRIDE", iDomainUnq))
		If ( iULAllowed = "" ) Then
			G_ADMINISTRATION_ULLeft = Trim(DOMAIN_Conf_W_DomainUnq("IMAGEGALLERY_INITIAL_NUMUPLOAD", iDomainUnq))
			Call ACCNT_WriteADV("SB_IG_NUMALLOWED", G_ADMINISTRATION_ULLeft, "V", iAccountUnq, iDomainUnq, "PRIVATE")
		Else
			iULAllowed = CDbl(iULAllowed)
			If ( iULAllowed = -1 ) Then
				G_ADMINISTRATION_ULLeft = -1
			Else
				iULAlready = Trim(ACCNT_ReturnADV_W_DomainUnq("SB_IG_NUMUPLOADED", "V", iAccountUnq, 7, "OVERRIDE", iDomainUnq))
				If ( iULAlready = "" ) Then
					iULAlready = 0
				Else
					iULAlready = CDbl(iULAlready)
				End If
				G_ADMINISTRATION_ULLeft = iULAllowed - iULAlready
				If ( G_ADMINISTRATION_ULLeft = -1 ) Then	' incase the difference is -1
					G_ADMINISTRATION_ULLeft = 0
				End If
			End If
		End If
		
	End Function
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*	Increments the number of images the user has uploaded.							*
	'*																					*
	'************************************************************************************
	Sub G_ADMINISTRATION_IncrementUL(iAccountUnq, iDomainUnq)
		Dim iNumUL
		
		'--num files user has uploaded
		'	--SB_IG_NUMUPLOADED

		iNumUL = Trim(ACCNT_ReturnADV_W_DomainUnq("SB_IG_NUMUPLOADED", "V", iAccountUnq, 7, "OVERRIDE", iDomainUnq))
		If ( iNumUL = "" ) Then
			iNumUL = 1
		Else
			iNumUL = CDbl(iNumUL) + 1
		End If
		Call ACCNT_WriteADV("SB_IG_NUMUPLOADED", iNumUL, "V", iAccountUnq, iDomainUnq, "PRIVATE")
		Call ACCNT_WriteADV("SB_IG_NUMUPLOAD_LASTDATE", NOW, "V", iAccountUnq, iDomainUnq, "PRIVATE")
		
	End Sub
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*	Returns the number of bytes left in this users HD storage or -1 for unlimited 	*
	'*		for the accountunq passed in.												*
	'*																					*
	'************************************************************************************
	Function G_ADMINISTRATION_HDSpaceLeft(iAccountUnq, iDomainUnq)
		Dim iTtlUsed, iTtlHD
	
		'--hd space the user has
		'	--SB_IG_TTLUPLOADABLE
		'--hd space user has used
		'	--SB_IG_TTLUPLOADED
		
		iTtlHD = Trim(ACCNT_ReturnADV_W_DomainUnq("SB_IG_TTLUPLOADABLE", "V", iAccountUnq, 7, "OVERRIDE", iDomainUnq))
		If ( iTtlHD = "" ) Then
			G_ADMINISTRATION_HDSpaceLeft = Trim(DOMAIN_Conf_W_DomainUnq("IMAGEGALLERY_INITIAL_HD_SPACE", iDomainUnq))
			Call ACCNT_WriteADV("SB_IG_TTLUPLOADABLE", G_ADMINISTRATION_HDSpaceLeft, "V", iAccountUnq, iDomainUnq, "PRIVATE")
		Else
			iTtlHD = CDbl(iTtlHD)
			If ( iTtlHD = -1 ) Then
				G_ADMINISTRATION_HDSpaceLeft = -1
			Else
				iTtlUsed = Trim(ACCNT_ReturnADV_W_DomainUnq("SB_IG_TTLUPLOADED", "V", iAccountUnq, 7, "OVERRIDE", iDomainUnq))
				If ( iTtlUsed = "" ) Then
					G_ADMINISTRATION_HDSpaceLeft = iTtlHD
				Else
					iTtlUsed = CDbl(iTtlUsed)
					G_ADMINISTRATION_HDSpaceLeft = iTtlHD - iTtlUsed
					If ( G_ADMINISTRATION_HDSpaceLeft = -1 ) Then	' we've already checked for unlimited, so this just happens that the difference is -1
						G_ADMINISTRATION_HDSpaceLeft = 0
					End If
				End If
			End If
		End If
		
	End Function
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*	Increments the users harddrive space left.										*
	'*																					*
	'************************************************************************************
	Sub G_ADMINISTRATION_IncrementHDSpaceUsed(iAccountUnq, iBytes, iDomainUnq)
		Dim iTtlUsed

		iTtlUsed = Trim(ACCNT_ReturnADV_W_DomainUnq("SB_IG_TTLUPLOADED", "V", iAccountUnq, 7, "OVERRIDE", iDomainUnq))
		If ( iTtlUsed = "" ) Then
			iTtlUsed = 0
		Else
			iTtlUsed	= CDbl(iTtlUsed)
		End If
		iBytes		= CDbl(iBytes)
		iTtlUsed	= CDbl(CDbl(iTtlUsed) + CDbl(iBytes))
		Call ACCNT_WriteADV("SB_IG_TTLUPLOADED", iTtlUsed, "V", iAccountUnq, iDomainUnq, "PRIVATE")
		
	End Sub
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*	Checks to see if ASPImage is installed or not.									*
	'*																					*
	'************************************************************************************
	Function G_ADMINISTRATION_ASPImageInstalled()
		Dim objASPImage, sTemp
		
		sTemp = UCase(Trim(DOMAIN_Conf("IMAGEGALLERY_THUMBNAIL_GENERATOR")))
		G_ADMINISTRATION_ASPImageInstalled = 0
		
		If ( sTemp = "ASPIMAGE" ) Then
			On Error Resume Next
			Set objASPImage = Server.CreateObject("AspImage.Image")
			If ( Err.Number <> 0 ) Then
				G_ADMINISTRATION_ASPImageInstalled = 0
			Else
				G_ADMINISTRATION_ASPImageInstalled = ASPIMAGE
			End If
			Set objASPImage = Nothing
			On Error Goto 0
		ElseIf ( sTemp = "GFL" ) Then
			'On Error Resume Next
			Set objASPImage = Server.CreateObject("GflAx.GflAx")
			If ( Err.Number <> 0 ) Then
				G_ADMINISTRATION_ASPImageInstalled = 0
			Else
				G_ADMINISTRATION_ASPImageInstalled = GFL
			End If
			Set objASPImage = Nothing
			'On Error Goto 0
		ElseIf ( sTemp = "IMAGEMAGICK" ) Then
			' this is implemented using a second function so that the second function can be called before the
			'	IMAGEMAGICK Conf Var value is implemented -- there are only a couple places in sitebeater that
			'	use IMAGEMAGICK, and they need to call the function independent of G_ADMINISTRATION_ASPImageInstalled()
			G_ADMINISTRATION_ASPImageInstalled = G_ADMINISTRATION_DetectImageMagick()
		Else
			G_ADMINISTRATION_ASPImageInstalled = 0
		End If
		
		iThumbComponent = G_ADMINISTRATION_ASPImageInstalled	' set the global variable so other functions can access it
		
	End Function
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*	Checks to see if ImageMagick is installed or not.								*
	'*		Doing this in a seperate function so ImageMagick can be partially implmented*
	'*																					*
	'************************************************************************************
	Function G_ADMINISTRATION_DetectImageMagick()
		Dim objASPImage
		
		On Error Resume Next
		Set objASPImage = Server.CreateObject("ImageMagickObject.MagickImage.1")
		If ( Err.Number <> 0 ) Then
			G_ADMINISTRATION_DetectImageMagick = 0
		Else
			G_ADMINISTRATION_DetectImageMagick = IMAGEMAGICK
		End If
		Set objASPImage = Nothing
		On Error Goto 0
		
	End Function
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*	Returns the number of bytes left in this users HD storage or -1 for unlimited 	*
	'*		for the accountunq passed in.												*
	'*																					*
	'************************************************************************************
	Function G_ADMINISTRATION_GalleriesLeft(iAccountUnq, iDomainUnq)
		Dim iGalleriesAllowed, iGalleriesAlready
		Dim sSQLText, rsImageGallery
	
		iGalleriesAllowed = Trim(ACCNT_ReturnADV_W_DomainUnq("SB_IG_NUM_GALLERIES", "V", iAccountUnq, 7, "OVERRIDE", iDomainUnq))

		Set rsImageGallery = Server.CreateObject("ADODB.recordset")
		sSQLText = "SELECT Count(*) FROM Galleries G (NOLOCK) WHERE AccountUnq = " & iAccountUnq & " AND Domain = " & iDomainUnq
		rsImageGallery.Open sSQLText, ImageGalleryConnection, adOpenKeyset, adLockReadOnly, adCmdText
		If (NOT rsImageGallery.EOF) Then
			iGalleriesAlready = rsImageGallery(0)
		Else
			iGalleriesAlready = 0
		End If
		rsImageGallery.Close
		Set rsImageGallery = Nothing

		If ( iGalleriesAllowed = "" ) Then
			iGalleriesAllowed = Trim(DOMAIN_Conf_W_DomainUnq("IMAGEGALLERY_INITIAL_MAX_NUM_GALLERIES", iDomainUnq))
			Call ACCNT_WriteADV("SB_IG_NUM_GALLERIES", iGalleriesAllowed, "V", iAccountUnq, iDomainUnq, "PRIVATE")

			If ( iGalleriesAllowed = "" ) Then
				iGalleriesAllowed = 0
			Else
				iGalleriesAllowed = CDbl(iGalleriesAllowed)
			End If

		Else
			iGalleriesAllowed = CDbl(iGalleriesAllowed)
		End If
		
		If ( iGalleriesAllowed = -1 ) Then
			G_ADMINISTRATION_GalleriesLeft = -1
		Else
			G_ADMINISTRATION_GalleriesLeft = iGalleriesAllowed - iGalleriesAlready
			If ( G_ADMINISTRATION_GalleriesLeft = -1 ) Then	' incase the difference is -1
				G_ADMINISTRATION_GalleriesLeft = 0
			End If
		End If
	
	End Function
	'************************************************************************************
	
	
	
	'************************************************************************************
	'*																					*
	'*																					*
	'*																					*
	'************************************************************************************
	Sub G_ADMINISTRATION_SendSubscriptionEmail(iGalleryUnq)
		Dim sFullLetter, rsImageGallery, sSQLText, iCategoryUnq, sEmailResponse, iAccountUnq
		Dim sEmail
	
		' don't send anything about a specific image since the admin could have uploaded many via the bulk upload.
		' must figure out the CategoryUnq from the GalleryUnq and see first if the user is subscribed to the gallery, then to the category
		
		If ( iGalleryUnq <> "" ) And ( DOMAIN_Has_RemoteHost() ) Then
			Set rsImageGallery = CreateObject("ADODB.Recordset")
			sSQLText = "SELECT S.AccountUnq, G.Name, G.CategoryUnq FROM IG_Subscriptions S (NOLOCK), Galleries G (NOLOCK) WHERE S.GalleryUnq = " & iGalleryUnq & " AND S.SentEmail = 'N' AND G.GalleryUnq = " & iGalleryUnq
			rsImageGallery.Open sSQLText, ImageGalleryConnection, adOpenKeyset, adLockReadOnly, adCmdText
			If ( NOT rsImageGallery.EOF ) Then

				' send emails to people who are subscribed to the gallery
				While ( NOT rsImageGallery.EOF )
					iAccountUnq = rsImageGallery("AccountUnq")
					sFullLetter = DOMAIN_Text("GALLERY_GAL_SUBSCRIPTION_BODY")
					sFullLetter = Replace(sFullLetter, "1:", rsImageGallery("Name"))
					sFullLetter = Replace(sFullLetter, "2:", Request.ServerVariables("SERVER_NAME"))
					sFullLetter = Replace(sFullLetter, "3:", sPath)
					sFullLetter = Replace(sFullLetter, "4:", iGalleryUnq)
					sFullLetter = Replace(sFullLetter, "5:", rsImageGallery("CategoryUnq"))
					sName		= Trim(ACCNT_ReturnADV("SB_FirstName", "V", iAccountUnq, 0, "OVERRIDE")) & " " & Trim(ACCNT_ReturnADV("SB_LastName", "V", iAccountUnq, 7, "OVERRIDE"))
					sEmail		= Trim(ACCNT_ReturnADV("SB_EmailAddress", "V", iAccountUnq, 0, "OVERRIDE"))
					If ( sEmail <> "" ) Then
						sEmailResponse = DOMAIN_Send_EMail(sFullLetter, DOMAIN_Conf("IMAGEGALLERY_SENDSUBSCRIPTIONS_FROM_NAME"), DOMAIN_Conf("IMAGEGALLERY_SENDSUBSCRIPTIONS_FROM_EMAIL"), sName, sEmail, Request.ServerVariables("SERVER_NAME") & " " & DOMAIN_Text("GALLERY_GAL_SUBSCRIPTION_SUBJECT"), FALSE)
					End If
					ImageGalleryConnection.Execute "UPDATE IG_Subscriptions SET SentEmail = 'Y' WHERE AccountUnq = " & iAccountUnq
					rsImageGallery.MoveNext
				Wend
				rsImageGallery.Close
				
				' now sent emails to people who are subscribed to the category that the gallery is in, if they didn't already get it from the gallery
				sSQLText = "SELECT CategoryUnq FROM Galleries (NOLOCK) WHERE GalleryUnq = " & iGalleryUnq
				rsImageGallery.Open sSQLText, ImageGalleryConnection, adOpenKeyset, adLockReadOnly, adCmdText
				If ( NOT rsImageGallery.EOF ) Then
					iCategoryUnq = rsImageGallery("CategoryUnq")
				End If
				rsImageGallery.Close
				
				If ( iCategoryUnq <> "" ) Then
					sSQLText = "SELECT AccountUnq FROM IG_Subscriptions (NOLOCK) WHERE CategoryUnq = " & iCategoryUnq & " AND GalleryUnq <> " & iGalleryUnq & " AND SentEmail = 'N'"
					rsImageGallery.Open sSQLText, ImageGalleryConnection, adOpenKeyset, adLockReadOnly, adCmdText				
					While ( NOT rsImageGallery.EOF )
						iAccountUnq = rsImageGallery("AccountUnq")
						sFullLetter = DOMAIN_Text("GALLERY_CAT_SUBSCRIPTION_BODY")
						sFullLetter = Replace(sFullLetter, "1:", G_ADMINISTRATION_GetCatName(iCategoryUnq))
						sFullLetter = Replace(sFullLetter, "2:", Request.ServerVariables("SERVER_NAME"))
						sFullLetter = Replace(sFullLetter, "3:", sPath)
						sFullLetter = Replace(sFullLetter, "4:", iCategoryUnq)
						sName		= Trim(ACCNT_ReturnADV("SB_FirstName", "V", iAccountUnq, 0, "OVERRIDE")) & " " & Trim(ACCNT_ReturnADV("SB_LastName", "V", iAccountUnq, 7, "OVERRIDE"))
						sEmail		= Trim(ACCNT_ReturnADV("SB_EmailAddress", "V", iAccountUnq, 0, "OVERRIDE"))
						If ( sEmail <> "" ) Then
							sEmailResponse = DOMAIN_Send_EMail(sFullLetter, DOMAIN_Conf("IMAGEGALLERY_SENDSUBSCRIPTIONS_FROM_NAME"), DOMAIN_Conf("IMAGEGALLERY_SENDSUBSCRIPTIONS_FROM_EMAIL"), sName, sEmail, Request.ServerVariables("SERVER_NAME") & " " & DOMAIN_Text("GALLERY_CAT_SUBSCRIPTION_SUBJECT"), FALSE)
						End If
						
						ImageGalleryConnection.Execute "UPDATE IG_Subscriptions SET SentEmail = 'Y' WHERE AccountUnq = " & iAccountUnq
						rsImageGallery.MoveNext
					Wend
					rsImageGallery.Close
				End If
			Else
				rsImageGallery.Close
			End If
			Set rsImageGallery = Nothing
		End If

	
	End Sub
	'************************************************************************************
	
	
	
	'************************************************************************************
	'*																					*
	'*																					*
	'*																					*
	'************************************************************************************
	Function G_ADMINISTRATION_HasGallerySubscription(iAccountUnq, iGalleryUnq)
		Dim rsImageGallery, sSQLText
		
		If ( iGalleryUnq <> "" ) Then
			Set rsImageGallery = CreateObject("ADODB.Recordset")
			sSQLText = "SELECT AccountUnq FROM IG_Subscriptions (NOLOCK) WHERE AccountUnq = " & iAccountUnq & " AND GalleryUnq = " & iGalleryUnq
			rsImageGallery.Open sSQLText, ImageGalleryConnection, adOpenKeyset, adLockReadOnly, adCmdText
			If ( NOT rsImageGallery.EOF ) Then
				G_ADMINISTRATION_HasGallerySubscription = TRUE
			Else
				G_ADMINISTRATION_HasGallerySubscription = FALSE
			End If
			rsImageGallery.Close
			Set rsImageGallery = Nothing
		End If
		
	End Function
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*																					*
	'*																					*
	'************************************************************************************
	Function G_ADMINISTRATION_HasCategorySubscription(iAccountUnq, iCategoryUnq)
		Dim rsImageGallery, sSQLText
		
		If ( iCategoryUnq <> "" ) Then
			Set rsImageGallery = CreateObject("ADODB.Recordset")
			sSQLText = "SELECT AccountUnq FROM IG_Subscriptions (NOLOCK) WHERE AccountUnq = " & iAccountUnq & " AND CategoryUnq = " & iCategoryUnq
			rsImageGallery.Open sSQLText, ImageGalleryConnection, adOpenKeyset, adLockReadOnly, adCmdText
			If ( NOT rsImageGallery.EOF ) Then
				G_ADMINISTRATION_HasCategorySubscription = TRUE
			Else
				G_ADMINISTRATION_HasCategorySubscription = FALSE
			End If
			rsImageGallery.Close
			Set rsImageGallery = Nothing
		End If

	End Function
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*																					*
	'*																					*
	'************************************************************************************
	Sub G_ADMINISTRATION_ResetSubscriptionEmail(iAccountUnq)
		ImageGalleryConnection.Execute "UPDATE IG_Subscriptions SET SentEmail = 'N' WHERE AccountUnq = " & iAccountUnq
	End Sub
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*																					*
	'*																					*
	'************************************************************************************
	Function G_ADMINISTRATION_EZPrintsAccount(iDomainUnq)
		G_ADMINISTRATION_EZPrintsAccount = FALSE
	End Function
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*	Returns the full path of the gallery owner of the primary gallery and domain of *
	'*		the ImageUnq passed in (doesn't have the image name on it so this can be	*
	'*		used for either images or thumbnails).										*
	'*																					*
	'************************************************************************************
	Function G_ADMINISTRATION_GetImageDir(iImageUnq)
		Dim rsImageGallery, sSQLText
		
		If ( iImageUnq <> "" ) Then
			Set rsImageGallery = CreateObject("ADODB.Recordset")
			sSQLText = "SELECT G.GalleryUnq, G.AccountUnq, G.Domain FROM Galleries G (NOLOCK), ImagesInGallery IG (NOLOCK) WHERE IG.ImageUnq = " & iImageUnq & " AND IG.PrimaryG = G.GalleryUnq AND IG.PrimaryD = G.Domain AND IG.GalleryUnq = IG.PrimaryG"
			rsImageGallery.Open sSQLText, ImageGalleryConnection, adOpenKeyset, adLockReadOnly, adCmdText
			If ( NOT rsImageGallery.EOF ) Then
				G_ADMINISTRATION_GetImageDir = "\" & DOMAIN_Conf_W_DomainUnq("IG", rsImageGallery("Domain")) & "\" & rsImageGallery("AccountUnq") & "\" & rsImageGallery("GalleryUnq") & "\"
			End If
			rsImageGallery.Close
			Set rsImageGallery = Nothing
		End If
	End Function
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*	Returns the name of the gallery.												*
	'*																					*
	'************************************************************************************
	Function G_ADMINISTRATION_GetGalleryName(iGalleryUnq)
		Dim rsImageGallery, sSQLText
		
		If ( iGalleryUnq <> "" ) Then
			Set rsImageGallery = CreateObject("ADODB.Recordset")
			sSQLText = "SELECT Name FROM Galleries (NOLOCK) WHERE GalleryUnq = " & iGalleryUnq
			rsImageGallery.Open sSQLText, ImageGalleryConnection, adOpenKeyset, adLockReadOnly, adCmdText
			If ( NOT rsImageGallery.EOF ) Then
				G_ADMINISTRATION_GetGalleryName = Trim(rsImageGallery("Name"))
			End If
			rsImageGallery.Close
			Set rsImageGallery = Nothing
		End If
	End Function
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*	Returns the name of the category.												*
	'*																					*
	'************************************************************************************
	Function G_ADMINISTRATION_GetCatName(iCategoryUnq)
		Dim rsImageGallery, sSQLText
		
		If ( iCategoryUnq <> "" ) Then
			Set rsImageGallery = CreateObject("ADODB.Recordset")
			sSQLText = "SELECT Name FROM IGCategories (NOLOCK) WHERE CategoryUnq = " & iCategoryUnq
			rsImageGallery.Open sSQLText, ImageGalleryConnection, adOpenKeyset, adLockReadOnly, adCmdText
			If ( NOT rsImageGallery.EOF ) Then
				G_ADMINISTRATION_GetCatName = Trim(rsImageGallery("Name"))
			End If
			rsImageGallery.Close
			Set rsImageGallery = Nothing
		End If
	End Function
	'************************************************************************************
%>